import { select,
         csv,
         scaleLinear,
         extent,
         min,
         max,
         axisLeft,
         axisBottom
       } from "d3"

import { dropDownMenu } from './dropDownMenu';
import { scatterPlot } from './scatterPlot';

const svg = select('svg');


const width = +svg.attr('width');
const height = +svg.attr("height");
// const xLegend = 'Weight'
const yLegend = 'Horsepower'
const title = 'Horsepower by weight'
let data;
let xColumn;
let yColumn;
const onXColumnClicked = column => {
  xColumn = column;
	render();
}

const onYColumnClicked = column => {
  yColumn = column;
	render();
}

const render = () => {
  //   	 d.acceleration = +d.acceleration;
  //     d.cylinders = +d.cylinders;
  //     d.displacement = +d.displacement;
  //     d.horsepower = +d.horsepower;
  //     d.mpg = +d.mpg;
  //     d.weight = +d.weight;
  //     d.year = +d.year;
	
  
  select('#x-menu')
    .call(dropDownMenu, {
      options: data.columns,
    	onOptionClicked: onXColumnClicked,
    	selectedOption: xColumn
    });
  
	select('#y-menu')
    .call(dropDownMenu, {
      options: data.columns,
    	onOptionClicked: onYColumnClicked,
   		selectedOption: yColumn
    });

  
  svg.call(scatterPlot, {
    xValue: d => d[xColumn],
    yValue: d => d[yColumn],
    margin: { top:50,
              right: 40,
              bottom: 100,
              left: 100
                 },
    radius: 10,
    xLegend: xColumn,
    yLegend: yColumn,
    width,
    height,
    data
  });
};


csv('https://vizhub.com/curran/datasets/auto-mpg.csv')
  .then(loadedData => {
	  data = loadedData
    data.forEach(d => {
      d.acceleration = +d.acceleration;
      d.cylinders = +d.cylinders;
      d.displacement = +d.displacement;
      d.horsepower = +d.horsepower;
      d.mpg = +d.mpg;
      d.weight = +d.weight;
      d.year = +d.year;
    });
  	xColumn = data.columns[4];
  	yColumn = data.columns[0];
		render();
})